<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body>
    
    <div class="container">
        <div class="row">
            <div class="col-sm-12 text-center">
                <h1>Danh sách đơn hàng</h1>
            </div>
        </div>
        <br>
        <div class="row">
            <div class="col-sm-2">
                <label for="">Trạng thái Order</label>
            </div>
            <div class="col-sm-3">
                <select name="select-trang-thai" id="select-trang-thai" class="form-control">
                    <option value="">--- Chọn tất cả ---</option>
                    <option value="open">Open</option>
                    <option value="confirmed">Confirmed</option>
                    <option value="cancel">Cancel</option>
                </select>
            </div>
            <div class="col-sm-2">
                <label for="">Loại Pizza</label>
            </div>
            <div class="col-sm-3">
                <select name="select-loai-pizza" id="select-loai-pizza" class="form-control">
                    <option value="">--- Chọn tất cả ---</option>
                    <option value="hawaii">Hawaii</option>
                    <option value="Bacon">Thịt ba rọi</option>
                    <option value="Seafood">Hải Sản</option>
                </select>
            </div>
            <div class="col-sm-2">
                <button class="btn btn-primary form-control" id="btn-filter">Lọc</button>
            </div>
        </div>
        <br>
        <div class="row">
            <div class="col-sm-12">
                <table class="table table-striped table-hover" id="table">
                    <thead>
                        <tr>
                            <td>Order ID</td>
                            <td>Kích cỡ combo</td>
                            <td>Loại pizza</td>
                            <td>Nước uống</td>
                            <td>Thành tiền</td>
                            <td>Họ và tên</td>
                            <td>Số điện thoại</td>
                            <td>Trạng thái</td>
                            <td>Chi tiết</td>
                        </tr>
                    </thead>
                </table>
            </div>
        </div>
    </div>

    <!-- Modal Content -->
    <div class="bs-example">
        <div id="my-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title">Order Detail!!!</h5>
                    </div>
                    <div class="modal-body">
                        <div class="row">
                            <div class="col-sm-4 text-center">
                                <label for="">Mã đơn hàng</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" class="form-control" id="inp-orderId">
                            </div>
                        </div>
                        <br>
                        <div class="row">
                            <div class="col-sm-4 text-center">
                                <label for="">Cỡ combo</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" class="form-control" id="inp-kichCo">
                            </div>
                        </div>
                        <br>
                        <div class="row">
                            <div class="col-sm-4 text-center">
                                <label for="">Đường kính pizza</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" class="form-control" id="inp-duongKinh">
                            </div>
                        </div>
                        <br>
                        <div class="row">
                            <div class="col-sm-4 text-center">
                                <label for="">Sườn nướng (miếng)</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" class="form-control" id="inp-suon">
                            </div>
                        </div>
                        <br>
                        <div class="row">
                            <div class="col-sm-4 text-center">
                                <label for="">Đồ uống</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" class="form-control" id="inp-doUong">
                            </div>
                        </div>
                        <br>
                        <div class="row">
                            <div class="col-sm-4 text-center">
                                <label for="">Số lượng nước uống</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" class="form-control" id="inp-soLuongNuoc">
                            </div>
                        </div>
                        <br>
                        <div class="row">
                            <div class="col-sm-4 text-center">
                                <label for="">Mã voucher</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" class="form-control" id="inp-idVourcher">
                            </div>
                        </div>
                        <br>
                        <div class="row">
                            <div class="col-sm-4 text-center">
                                <label for="">Loại pizza</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" class="form-control" id="inp-loaiPizza">
                            </div>
                        </div>
                        <br>
                        <div class="row">
                            <div class="col-sm-4 text-center">
                                <label for="">Salad(g)</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" class="form-control" id="inp-salad">
                            </div>
                        </div>
                        <br>
                        <div class="row">   
                            <div class="col-sm-4 text-center">
                                <label for="">Thành tiền</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" class="form-control" id="inp-thanhTien">
                            </div>
                        </div>
                        <br>
                        <div class="row">
                            <div class="col-sm-4 text-center">
                                <label for="">Giảm giá</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" class="form-control" id="inp-giamGia">
                            </div>
                        </div>
                        <br>
                        <div class="row">
                            <div class="col-sm-4 text-center">
                                <label for="">Họ và tên</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" class="form-control" id="inp-hoTen">
                            </div>
                        </div>
                        <br>
                        <div class="row">
                            <div class="col-sm-4 text-center">
                                <label for="">Email</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" class="form-control" id="inp-email">
                            </div>
                        </div>
                        <br>
                        <div class="row">
                            <div class="col-sm-4 text-center">
                                <label for="">Số điện thoại</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" class="form-control" id="inp-soDienThoai">
                            </div>
                        </div>
                        <br>
                        <div class="row">
                            <div class="col-sm-4 text-center">
                                <label for="">Địa chỉ</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" class="form-control" id="inp-diaChi">
                            </div>
                        </div>
                        <br>
                        <div class="row">
                            <div class="col-sm-4 text-center">
                                <label for="">Lời nhắn</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" class="form-control" id="inp-loiNhan">
                            </div>
                        </div>
                        <br>
                        <div class="row">
                            <div class="col-sm-4 text-center">
                                <label for="">Trạng thái đơn hàng</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" class="form-control" id="inp-trangThai">
                            </div>
                        </div>
                        <br>
                        <div class="row">
                            <div class="col-sm-4 text-center">
                                <label for="">Ngày tạo đơn</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" class="form-control" id="inp-ngayTao">
                            </div>
                        </div>
                        <br>
                        <div class="row">
                            <div class="col-sm-4 text-center">
                                <label for="">Ngày cập nhật</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" class="form-control" id="inp-ngayCapNhat">
                            </div>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button id="btn-accept" class="btn btn-success">Đồng ý</button>
                        <button id="btn-cancel" class="btn btn-success">Huỷ bỏ</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
</body>
<script>
    $(document).ready(function(){
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        //Khai báo các hằng số 
        const gORDER_ID_COL = 0;
        const gKICH_CO_COL = 1;
        const gLOAI_PIZZA_COL = 2;
        const gID_LOAI_NUOC_UONG_COL = 3;
        const gTHANH_TIEN_COL = 4;
        const gHO_TEN_COL = 5;
        const gSO_DIEN_THOAI_COL = 6;
        const gTRANG_THAI_COL = 7;
        const gACTION_COL = 8;
        //Biến mảng hằng số chứa danh sách các thuộc tính của datatable
        const gNameCol = ["orderId","kichCo","loaiPizza","idLoaiNuocUong","thanhTien","hoTen","soDienThoai","trangThai","action"];
        //Khai báo DataTable và mapping columns:
        var vDataTable = $("#table").DataTable({
            columns: [
                {data: gNameCol[gORDER_ID_COL]},
                {data: gNameCol[gKICH_CO_COL]},
                {data: gNameCol[gLOAI_PIZZA_COL]},
                {data: gNameCol[gID_LOAI_NUOC_UONG_COL]},
                {data: gNameCol[gTHANH_TIEN_COL]},
                {data: gNameCol[gHO_TEN_COL]},
                {data: gNameCol[gSO_DIEN_THOAI_COL]},
                {data: gNameCol[gTRANG_THAI_COL]},
                {data: gNameCol[gACTION_COL]},
            ],
            columnDefs:[
                {
                    targets: gACTION_COL,
                    defaultContent: "<button class='btn btn-primary btn-detail'>Chi tiết</button>"
                }
            ]
        });
        //Biến chứa response object trả về :
        var vDataTableObject = [];
        //Biến chứa thông tin của nút detail
        var vDetailObject = {
                id:"",
                orderId:"",
            }
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
        onPageLoading();
        //Hàm xử lý sự kiện khi bấm nút filter
        $("#btn-filter").on("click",function(){
            onBtnFilterClick();
        })
        //Gán sự kiện cho nút chi tiết :
        $(document).on("click",".btn-detail",function(){
            onBtnDetailClick(this);
        });
        //Gán sự kiện cho nút đồng ý trong modal 
        $("#btn-accept").on("click",function(){
            onBtnAcceptClick();
        });
        //Gán sự kiện cho nút huỷ bỏ trong modal
        $("#btn-cancel").on("click",function(){
            onBtnCancelClick();
        })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        //Hàm tải trang
        function onPageLoading(){
            "use strict"
            //Bước 1 : Thu thập dữ liệu ( không có )
            //Bước 2 : Kiểm tra dữ liệu ( không có )
            //Bước 3 : Gọi sever 
            callAjaxToGetAllListOrder();
        }
        //Hàm xử lý sự kiện khi bấm nút filter
        function onBtnFilterClick(){
            "use strict"
            //Bước 1: Tạo object chứa dữ liệu :
            var vFilterObject = {
                trangThai:"",
                loaiPizza:"",
            }
            //Bước 2:Thu thập dữ liệu :
            getDataFilterObject(vFilterObject);
            console.log(vFilterObject);
            //Bước 3: Hàm kiểm tra dữ liệu (không có):
            //Bước 4 : Xử lý dữ liệu :
            filterData(vFilterObject);
        }
        //Hàm xử lý sự kiện khi bấm nút chi tiết :
        function onBtnDetailClick(paramButton){
            "use strict"
            //Hiển thị modal lên : 
            $("#my-modal").modal("show");
            //Bước 1 : Tạo object để thu thập dữ liệu : ( không có )
            //Bước 2 : Thu thập dữ liệu : 
            var vRowClick = $(paramButton).closest("tr");
            var vTable = $("#table").DataTable();
            var vDataRow = vTable.row(vRowClick).data();
            console.log(vDataRow);
            vDetailObject.id = vDataRow.id;
            vDetailObject.orderId = vDataRow.orderId;
            console.log(vDetailObject);
            //Bước 3 : Validate (không cần)
            //Bước 4 : Gọi sever và load dữ liệu lên form modal :
            callAjaxToGetOrder();
        }
        //Hàm xử lý sự kiện khi bấm nút đồng ý trong modal 
        function onBtnAcceptClick(){
            "use strict"
            var vId = vDetailObject.id;
            console.log(vId);
            var vObjectRequest = {
            trangThai: "confirmed" //3: trang thai open, confirmed, cancel tùy tình huống
            }
            //Gọi sever :
            $.ajax({
                url:"http://42.115.221.44:8080/devcamp-pizza365/orders/" + vId,
                type:"PUT",
                contentType:"application/json;charset=UTF-8",
                data: JSON.stringify(vObjectRequest),
                success: function(responseObject){
                    console.log(responseObject);
                    //Sau khi cập nhật thành công thì :
                    alert("Cập nhật thông tin thành công!!!");
                    //Ẩn modal đi !
                    $("#my-modal").modal("hide");
                    callAjaxToGetAllListOrder();
                },
                error: function (ajaxContext) {
                    alert(ajaxContext.responseText)
                } 
            });
        }
        //Hàm xử lý sự kiện cho nút huỷ bỏ trong modal
        function onBtnCancelClick(){
            "use strict"
            var vId = vDetailObject.id;
            console.log(vId);
            var vObjectRequest = {
            trangThai: "cancel" //3: trang thai open, confirmed, cancel tùy tình huống
            }
            //Gọi sever :
            $.ajax({
                url:"http://42.115.221.44:8080/devcamp-pizza365/orders/" + vId,
                type:"PUT",
                contentType:"application/json;charset=UTF-8",
                data: JSON.stringify(vObjectRequest),
                success: function(responseObject){
                    console.log(responseObject);
                    //Sau khi cập nhật thành công thì :
                    alert("Cập nhật thông tin thành công!!!");
                    //Ẩn modal đi !
                    $("#my-modal").modal("hide");
                    callAjaxToGetAllListOrder();
                },
                error: function (ajaxContext) {
                    alert(ajaxContext.responseText)
                } 
            });        
        }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        function callAjaxToGetAllListOrder(){
            "use strict"
            $.ajax({
                url:"http://42.115.221.44:8080/devcamp-pizza365/orders",
                type:"GET",
                success: function(responseObject){
                    console.log(responseObject);
                    //Bước 4 : Xử lý dữ liệu :
                    vDataTableObject = responseObject;
                    //Load dữ liệu lên bảng bảng :
                    loadDataToTable(vDataTableObject);
                },
                error: function (ajaxContext) {
                    alert(ajaxContext.responseText)
                }
            });
        }
        //Hàm tải dữ liệu lên bảng
        function loadDataToTable(paramObject){
            "use strict"
            vDataTable.clear();
            vDataTable.rows.add(paramObject);
            vDataTable.draw();
        }
        //Hàm thu thập dữ liệu :
        function getDataFilterObject(paramFilterObject){
            "use strict"
            paramFilterObject.trangThai = $("#select-trang-thai option:checked").val();
            paramFilterObject.loaiPizza = $("#select-loai-pizza option:checked").val();
        }
        //Hàm lọc dữ liệu :
        function filterData(paramFilterObject){
            "use strict"
            var vFilteredObject = [];
            //Trường hợp 1 : Chỉ lọc trạng thái order
            if(paramFilterObject.trangThai !== "" && paramFilterObject.loaiPizza == ""){
                vFilteredObject = vDataTableObject.filter(function(paramObject){
                    return (paramObject.trangThai === paramFilterObject.trangThai);
                })
            };
            //Trường hợp 2: Chỉ lọc loại pizza 
            if(paramFilterObject.loaiPizza !== "" && paramFilterObject.trangThai == ""){
                vFilteredObject = vDataTableObject.filter(function(paramObject){
                    return (paramObject.loaiPizza === paramFilterObject.loaiPizza);
                });
            };
            //Trường hợp 3: Lọc cả loại pizza và trạng thái order 
            if(paramFilterObject.loaiPizza !== "" && paramFilterObject.trangThai !== ""){
                vFilteredObject = vDataTableObject.filter(function(paramObject){
                    return (paramObject.loaiPizza === paramFilterObject.loaiPizza && paramObject.trangThai === paramFilterObject.trangThai);
                });
            };
            //Trường hợp 4 : Không có dữ liệu lọc 
            if(paramFilterObject.loaiPizza === "" && paramFilterObject.trangThai === ""){
                vFilteredObject = vDataTableObject;
            }
            loadDataToTable(vFilteredObject);
        }
        //Hàm gọi sever
        function callAjaxToGetOrder(){
            "use strict"
            $.ajax({
                url:"http://42.115.221.44:8080/devcamp-pizza365/orders" + "/" + vDetailObject.orderId,
                type:"GET",
                success: function(responseObject){
                    console.log(responseObject);
                    //Xử lý dữ liệu :
                    loadDataOrderToFormModal(responseObject);
                },
                error: function (ajaxContext) {
                    alert(ajaxContext.responseText)
                }
            })
        }
        //
        function loadDataOrderToFormModal(paramResponseObject){
            "use strict"
            $("#inp-orderId").val(paramResponseObject.orderId);
            $("#inp-kichCo").val(paramResponseObject.kichCo);
            $("#inp-duongKinh").val(paramResponseObject.duongKinh);
            $("#inp-suon").val(paramResponseObject.suon);
            $("#inp-doUong").val(paramResponseObject.idLoaiNuocUong);
            $("#inp-soLuongNuoc").val(paramResponseObject.soLuongNuoc);
            $("#inp-idVourcher").val(paramResponseObject.idVourcher);
            $("#inp-loaiPizza").val(paramResponseObject.loaiPizza);
            $("#inp-salad").val(paramResponseObject.salad);
            $("#inp-thanhTien").val(paramResponseObject.thanhTien);
            $("#inp-giamGia").val(paramResponseObject.giamGia);
            $("#inp-hoTen").val(paramResponseObject.hoTen);
            $("#inp-email").val(paramResponseObject.email);
            $("#inp-soDienThoai").val(paramResponseObject.soDienThoai);
            $("#inp-diaChi").val(paramResponseObject.diaChi);
            $("#inp-loiNhan").val(paramResponseObject.loiNhan);
            $("#inp-trangThai").val(paramResponseObject.trangThai);
            $("#inp-ngayTao").val(paramResponseObject.ngayTao);
            $("#inp-ngayCapNhat").val(paramResponseObject.ngayCapNhat);
        }
    });
</script>
</html>